Loading...
Searching...
No Matches
TrcPktProcStm Class Reference
OpenCSD Library : Packet Processors.

`#include <trc_pkt_proc_stm.h>`

Inheritance diagram for TrcPktProcStm:
[legend]
Collaboration diagram for TrcPktProcStm:
[legend]

## Public Member Functions

| TrcPktProcStm ()
| TrcPktProcStm (int instIDNum)
virtual | ~TrcPktProcStm ()
Public Member Functions inherited from TrcPktProcBase< StmTrcPacket, ocsd_stm_pkt_type, STMConfig >
| TrcPktProcBase (const char *component_name)
| TrcPktProcBase (const char *component_name, int instIDNum)
virtual | ~TrcPktProcBase ()
virtual ocsd_datapath_resp_t | TraceDataIn (const ocsd_datapath_op_t op, const ocsd_trc_index_t index, const uint32_t dataBlockSize, const uint8_t *pDataBlock, uint32_t *numBytesProcessed)
componentAttachPt< IPktDataIn< StmTrcPacket > > * | getPacketOutAttachPt ()
| Attachement point for the protocol packet output.
componentAttachPt< IPktRawDataMon< StmTrcPacket > > * | getRawPacketMonAttachPt ()
| Attachment point for the protocol packet monitor.
componentAttachPt< ITrcPktIndexer< ocsd_stm_pkt_type > > * | getTraceIDIndexerAttachPt ()
| Attachment point for a packet indexer.
virtual ocsd_err_t | setProtocolConfig (const STMConfig *config)
| < Set the protocol specific configuration for the decoder.
virtual const STMConfig * | getProtocolConfig () const
virtual ocsd_err_t | getStatsBlock (ocsd_decode_stats_t **pp_stats)
virtual void | resetStats ()
Public Member Functions inherited from TrcPktProcI
| TrcPktProcI (const char *component_name)
| TrcPktProcI (const char *component_name, int instIDNum)
virtual | ~TrcPktProcI ()
Public Member Functions inherited from TraceComponent
| TraceComponent (const std::string &name)
| TraceComponent (const std::string &name, int instIDNum)
virtual | ~TraceComponent ()
const std::string & | getComponentName () const
void | setComponentName (const std::string &name)
componentAttachPt< ITraceErrorLog > * | getErrorLogAttachPt ()
ocsd_err_t | setComponentOpMode (uint32_t op_flags)
const uint32_t | getComponentOpMode () const
const uint32_t | getSupportedOpModes () const
void | setAssocComponent (TraceComponent *assocComp)
TraceComponent * | getAssocComponent ()
void | LogDefMessage (const std::string &msg)
Public Member Functions inherited from ITrcDataIn
| ITrcDataIn ()
virtual | ~ITrcDataIn ()

## Protected Types

enum | _process_state { WAIT_SYNC , PROC_HDR , PROC_DATA , SEND_PKT }
typedef enum TrcPktProcStm::_process_state | process_state

## Protected Member Functions

virtual ocsd_datapath_resp_t | processData (const ocsd_trc_index_t index, const uint32_t dataBlockSize, const uint8_t *pDataBlock, uint32_t *numBytesProcessed)
| Implementation function for the OCSD_OP_DATA operation.
virtual ocsd_datapath_resp_t | onEOT ()
| Implementation function for the OCSD_OP_EOT operation.
virtual ocsd_datapath_resp_t | onReset ()
| Implementation function for the OCSD_OP_RESET operation.
virtual ocsd_datapath_resp_t | onFlush ()
| Implementation function for the OCSD_OP_FLUSH operation.
virtual ocsd_err_t | onProtocolConfig ()
| Called when the configuration object is passed to the decoder.
virtual const bool | isBadPacket () const
| check if the current packet is an error / bad packet
Protected Member Functions inherited from TrcPktProcBase< StmTrcPacket, ocsd_stm_pkt_type, STMConfig >
ocsd_datapath_resp_t | outputDecodedPacket (const ocsd_trc_index_t index_sop, const StmTrcPacket *pkt)
void | outputRawPacketToMonitor (const ocsd_trc_index_t index_sop, const StmTrcPacket *pkt, const uint32_t size, const uint8_t *p_data)
void | indexPacket (const ocsd_trc_index_t index_sop, const ocsd_stm_pkt_type *packet_type)
ocsd_datapath_resp_t | outputOnAllInterfaces (const ocsd_trc_index_t index_sop, const StmTrcPacket *pkt, const ocsd_stm_pkt_type *pkt_type, std::vector< uint8_t > &pktdata)
ocsd_datapath_resp_t | outputOnAllInterfaces (const ocsd_trc_index_t index_sop, const StmTrcPacket *pkt, const ocsd_stm_pkt_type *pkt_type, const uint8_t *pktdata, uint32_t pktlen)
const bool | hasRawMon () const
void | ClearConfigObj ()
const bool | checkInit ()
void | statsAddTotalCount (const uint64_t count)
void | statsAddUnsyncCount (const uint64_t count)
void | statsAddBadSeqCount (const uint32_t count)
void | statsAddBadHdrCount (const uint32_t count)
void | statsInit ()
Protected Member Functions inherited from TraceComponent
void | LogError (const ocsdError &Error)
void | LogMessage (const ocsd_err_severity_t filter_level, const std::string &msg)
const ocsd_err_severity_t | getErrorLogLevel () const
const bool | isLoggingErrorLevel (const ocsd_err_severity_t level) const
void | updateErrorLogLevel ()
void | do_attach_notify (const int num_attached)
void | Init (const std::string &name)

## Protected Attributes

process_state | m_proc_state
Protected Attributes inherited from TrcPktProcBase< StmTrcPacket, ocsd_stm_pkt_type, STMConfig >
const STMConfig * | m_config
Protected Attributes inherited from TraceComponent
uint32_t | m_op_flags
| current component operational mode flags.
uint32_t | m_supported_op_flags
| supported component operational mode flags - derived class to intialise.

## Detailed Description

Definition at line 48 of file trc_pkt_proc_stm.h.

## Member Typedef Documentation

## process_state

typedef enum TrcPktProcStm::_process_state TrcPktProcStm::process_state

protected

## Member Enumeration Documentation

## _process_state

enum TrcPktProcStm::_process_state

protected

Enumerator
WAIT_SYNC |
PROC_HDR |
PROC_DATA |
SEND_PKT |

Definition at line 68 of file trc_pkt_proc_stm.h.

## Constructor & Destructor Documentation

## TrcPktProcStm() [1/2]

TrcPktProcStm::TrcPktProcStm | ( |  | ) |

## TrcPktProcStm() [2/2]

TrcPktProcStm::TrcPktProcStm | ( | int | instIDNum | ) |

## ~TrcPktProcStm()

virtual TrcPktProcStm::~TrcPktProcStm | ( |  | ) |

virtual

## Member Function Documentation

## isBadPacket()

virtual const bool TrcPktProcStm::isBadPacket | ( |  | ) | const

protected virtual

check if the current packet is an error / bad packet

Implements TrcPktProcI.

## onEOT()

virtual ocsd_datapath_resp_t TrcPktProcStm::onEOT | ( |  | ) |

protected virtual

Implementation function for the OCSD_OP_EOT operation.

Implements TrcPktProcI.

## onFlush()

virtual ocsd_datapath_resp_t TrcPktProcStm::onFlush | ( |  | ) |

protected virtual

Implementation function for the OCSD_OP_FLUSH operation.

Implements TrcPktProcI.

## onProtocolConfig()

virtual ocsd_err_t TrcPktProcStm::onProtocolConfig | ( |  | ) |

protected virtual

Called when the configuration object is passed to the decoder.

Implements TrcPktProcI.

## onReset()

virtual ocsd_datapath_resp_t TrcPktProcStm::onReset | ( |  | ) |

protected virtual

Implementation function for the OCSD_OP_RESET operation.

Implements TrcPktProcI.

## processData()

virtual ocsd_datapath_resp_t TrcPktProcStm::processData | ( | const ocsd_trc_index_t | index,
|  | const uint32_t | dataBlockSize,
|  | const uint8_t * | pDataBlock,
|  | uint32_t * | numBytesProcessed
| ) |  |

protected virtual

Implementation function for the OCSD_OP_DATA operation.

Implements TrcPktProcI.

## Member Data Documentation

## m_proc_state

process_state TrcPktProcStm::m_proc_state

protected

Definition at line 75 of file trc_pkt_proc_stm.h.

The documentation for this class was generated from the following file:

- /build/libopencsd-16huoW/libopencsd-1.4.1/decoder/include/opencsd/stm/trc_pkt_proc_stm.h